################################################################################
#
# Sample string decrypter for dirtyJOE, with proper key it can decrypt strings
# from files obfuscated by Zelix KlassMaster.
#
# Copyright 2011 ReWolf
#
################################################################################

def dj_decryptUTF8_ZKM(inBuffer, key):
	i = 0
	ik = 0
	ret = []
	last = len(inBuffer)
	while i < last:
		c = inBuffer[i]
		if c == 0:
			break
		defAdd = 1
		if (c >> 5) == 6:
			c = ((c & 0x1f) << 6) + (inBuffer[i+1] & 0x3f)
			defAdd = 2
		elif (c >> 4) == 0xE:
			c = ((c & 0xf) << 12) + ((inBuffer[i+1] & 0x3f) << 6) + (inBuffer[i+2] & 0x3f)
			defAdd = 3

		ret += [c ^ key[ik % 5]]
		i += defAdd
		ik += 1
	return ret


# 'instr' argument is input buffer represented as tuple
# function should return list object
def dj_decryptUTF8(inBuf):
	key = [1, 2, 3, 4, 5]
	return dj_decryptUTF8_ZKM(inBuf, key)
